function varargout = testbench(varargin)
% TESTBENCH MATLAB code for testbench.fig
%      TESTBENCH, by itself, creates a new TESTBENCH or raises the existing
%      singleton*.
%
%      H = TESTBENCH returns the handle to a new TESTBENCH or the handle to
%      the existing singleton*.
%
%      TESTBENCH('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in TESTBENCH.M with the given input arguments.
%
%      TESTBENCH('Property','Value',...) creates a new TESTBENCH or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before testbench_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to testbench_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help testbench

% Last Modified by GUIDE v2.5 04-Oct-2014 21:16:35

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @testbench_OpeningFcn, ...
                   'gui_OutputFcn',  @testbench_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


    function spectrum = plotter(handles, where)
        
        spectrum = 0;
        color = 0;
        
        switch where
            case 1
                ax = handles.axes1;
                data = handles.sine;
                time = 0:1/handles.sampfreq:(handles.timeframe/1000)-1/handles.sampfreq;
            case 2
                ax = handles.axes3;
                data = handles.processed;
                time = handles.time2;
            otherwise
                return
        end
        
        if handles.domain == 2
            
            if (handles.pulsator == 1) && (handles.compare == 1) && (where == 2)
                color = 1;
                len1 = numel(handles.sine);
                len2 = numel(data);
                if len1 < len2
                    fix = zeros(1,len1);
                    for i = 1:len1
                        fix(i) = data(i);
                    end
                    data = fix;
                else
                    for i = len2:len1
                        data(i) = 0;
                    end
                end
            end
            
            tran = fft(data);
            
            inc = handles.sampfreq/length(data);
            fax = 0:inc:handles.sampfreq-inc;
            
            y = 2*(abs(tran)/length(tran));
            
            if (where == 1) && (handles.pulsator == 1)
                spectrum = y;
            end
            
            if color
                for d = 1:numel(handles.spectrum)
                    y(d) = 20*log10(y(d)/handles.spectrum(d));   %logarithmic scale
                end
            end
            ho = plot(ax,fax,y);
            grid(ax, 'on');
            
            if color
                set(ho,'LineWidth',2);
                set(ho,'Color','r');
                set(handles.unitdb, 'Visible', 'On');
            else
                if where == 2
                    set(handles.unitdb, 'Visible', 'Off');
                end
            end
            set(handles.unit1, 'String', 'Hz');
            set(handles.unit2, 'String', 'Hz');
        end

        if handles.domain == 1
            if handles.pulsator
                ho = stem(ax,time,data);
            else
                ho = plot(ax,time,data);
            end
            grid(ax, 'on');
            if where == 2
                 set(handles.unitdb, 'Visible', 'Off');
                 if handles.satur
                     set(ho, 'Color', 'm');
                 end
            end
            set(handles.unit1, 'String', 's');
            set(handles.unit2, 'String', 's');
        end
        
        function resizer(handles)
        xmag = xlim(handles.axes1);
        xlim(handles.axes3, xmag);
        

        function siner = displayer(handles)

        getmaxt = handles.timeframe/1000;
        t = 0:1/handles.sampfreq:getmaxt-1/handles.sampfreq;
        siner = zeros(1,length(t));
        siner(1:length(t)) = handles.dcvalue;
        for id = 1:handles.sid
            siner = siner + handles.amplit(id)*sin(2*pi*handles.sigfreq(id)*t+handles.phase(id));
        end
        
function spikes = pulserender(handles)
    
    time = 0:1/handles.sampfreq:(handles.timeframe/1000)-1/handles.sampfreq;
    timebox = numel(time);
    spikes = zeros(1,timebox);
    for id = 1:handles.sid
        position = handles.ppos(id) + 1;
        if position <= timebox
            spikes(position) = spikes(position) + handles.amplit(id);
        end
    end
    

% --- Executes just before testbench is made visible.
function testbench_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to testbench (see VARARGIN)
handles.online = 0;

handles.domain = 1;
handles.sampfreq = 50000;
getmaxt = 0.01;
t = 0:1/handles.sampfreq:getmaxt-1/handles.sampfreq;
y = zeros(1,length(t));
handles.sine = y;
handles.processed = y;
handles.time2 = t;
handles.spectrum = 0;

handles.pulsator = 0;
handles.sid = 0;
handles.sigfreq = zeros(1,50);
handles.amplit = zeros(1,50);
handles.phase = zeros(1,50);
handles.ppos = zeros(1,50);
handles.tsigfreq = 500;
handles.tamplit = 1;
handles.newsig = 1;
handles.timeframe = 10;
handles.dcvalue = 0;
handles.compare = 0;
handles.packet = 10;
handles.satur = 0;

plotter(handles, 1);
plotter(handles, 2);
resizer(handles);

handles.ppost = 3;     %PulsePOSitionTemporary
handles.phaset = 0;

    serialInfo = instrhwinfo('serial');
    if isempty(serialInfo.AvailableSerialPorts)
        set(handles.portsel, 'String', ' ');
        handles.comport = 0;
        set(handles.Connect, 'Enable', 'Off');
    else
        set(handles.portsel, 'String', serialInfo.AvailableSerialPorts);
        handles.comport = serialInfo.AvailableSerialPorts{1};
    end
    
handles.show = 1;

handles.fstager = 1;
handles.istager = 1;
handles.stiming = 20;

        %fir filter b0b1b2b3b4b5b6b7b8b9

handles.fircoeffs = [1 0 0 0 0 0 0 0 0 0];

        %iir filter b0[]b1b2a1a2b0[]b1b2a1a2
                  %----2-----------8--------
handles.iircoeffs = [1 0 0 0 0 0 1 0 0 0 0 0];


% Choose default command line output for testbench
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes testbench wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = testbench_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in addsinebutton.
function addsinebutton_Callback(hObject, eventdata, handles)
% hObject    handle to addsinebutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.compare = 0;
handles.sid = handles.sid + 1;

if handles.tsigfreq == 0
    handles.dcvalue = handles.dcvalue + handles.tamplit;
else
    handles.amplit(handles.sid) = handles.tamplit;
end
handles.sigfreq(handles.sid) = handles.tsigfreq;
handles.phase(handles.sid) = handles.phaset;

handles.newsig = 0;

handles.sine = displayer(handles);
plotter(handles, 1);
plotter(handles, 2);
resizer(handles);

set(handles.pulsegen, 'Enable', 'Off');
set(handles.Blanking, 'Enable', 'On');

guidata(hObject, handles);

% --- Executes on button press in Blanking.
function Blanking_Callback(hObject, eventdata, handles)
% hObject    handle to Blanking (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.compare = 0;
handles.pulsator = 0;
handles.sid = 0;
handles.newsig = 1;
handles.sine = zeros(1,floor((handles.timeframe/1000)*handles.sampfreq));
handles.dcvalue = 0;
plotter(handles, 1);
plotter(handles, 2);
resizer(handles);

set(handles.addsinebutton, 'Enable', 'On');
set(handles.pulsegen, 'Enable', 'On');
set(handles.Blanking, 'Enable', 'Off');

guidata(hObject, handles);


% --- Executes on button press in pulsegen.
function pulsegen_Callback(hObject, eventdata, handles)
% hObject    handle to pulsegen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.compare = 0;
handles.pulsator = 1;
handles.sid = handles.sid + 1;

handles.amplit(handles.sid) = handles.tamplit;
handles.ppos(handles.sid) = handles.ppost;

handles.sine = pulserender(handles);
handles.spectrum = plotter(handles, 1);
plotter(handles, 2);
resizer(handles);

set(handles.addsinebutton, 'Enable', 'Off');
set(handles.Blanking, 'Enable', 'On');

guidata(hObject, handles);



% --- Executes on selection change in samplefreq.
function samplefreq_Callback(hObject, eventdata, handles)
% hObject    handle to samplefreq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns samplefreq contents as cell array
%        contents{get(hObject,'Value')} returns selected item from samplefreq

input = get(hObject,'Value');

handles.compare = 0;

switch input
    case 1
        handles.sampfreq = 100000;
        handles.stiming = 10;
    case 2
        handles.sampfreq = 76923;
        handles.stiming = 13;
    case 3
        handles.sampfreq = 50000;
        handles.stiming = 20;
    case 4
        handles.sampfreq = 45454;
        handles.stiming = 22;
    case 5
        handles.sampfreq = 40000;
        handles.stiming = 25;
    case 6
        handles.sampfreq = 34482;
        handles.stiming = 67; 
    case 7
        handles.sampfreq = 30303; 
        handles.stiming = 33;
    case 8
        handles.sampfreq = 25000;
        handles.stiming = 40;
    case 9
        handles.sampfreq = 20000;
        handles.stiming = 50;
    case 10
        handles.sampfreq = 14925;
        handles.stiming = 67;
    case 11
        handles.sampfreq = 10000;
        handles.stiming = 100;
    otherwise
        return
end

if handles.pulsator
    handles.sine = pulserender(handles);
else if handles.newsig
        handles.sine = zeros(1,floor((handles.timeframe/1000)*handles.sampfreq));
    else
        handles.sine = displayer(handles);
    end
end

if handles.show == 1
    plotter(handles,1);
end


guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function samplefreq_CreateFcn(hObject, eventdata, handles)
% hObject    handle to samplefreq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function amplitude_Callback(hObject, eventdata, handles)
% hObject    handle to amplitude (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of amplitude as text
%        str2double(get(hObject,'String')) returns contents of amplitude as a double
input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.amplitude, 'String', handles.tamplit);
  uicontrol(hObject)
  return
else
  handles.tamplit = input;
end
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function amplitude_CreateFcn(hObject, eventdata, handles)
% hObject    handle to amplitude (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function frequency_Callback(hObject, eventdata, handles)
% hObject    handle to frequency (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of frequency as text
%        str2double(get(hObject,'String')) returns contents of frequency as a double
input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.frequency, 'String', handles.tsigfreq);
  uicontrol(hObject)
  return
else
    if input < 0
        errordlg('Frequency must be positive','Invalid Input','modal')
        set(handles.frequency, 'String', handles.tsigfreq);
          uicontrol(hObject)
          return
    else
        handles.tsigfreq = input;
    end
end
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function frequency_CreateFcn(hObject, eventdata, handles)
% hObject    handle to frequency (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in ProcessFir.
function ProcessFir_Callback(hObject, eventdata, handles)
% hObject    handle to ProcessFir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%http://stackoverflow.com/questions/7519049/how-can-you-interupt-a-function-from-a-gui-callback-without-adding-an-interupt-c

set(handles.radiobutton1, 'Value', 1);
set(handles.radiobutton2, 'Value', 0);

handles.domain = 1;
handles.satur = 0;

plotter(handles, 1);
plotter(handles, 2);
resizer(handles);

rdisable(handles);

set(handles.figure1, 'UserData', 0);    %set an interrupt requirement

what = firkoeff(handles);

if what
    handles.online = 0;
    errordlg('MBED has stopped responding: check for loose USB cable, and try to reset before reconnecting.','Connection lost','modal')
    renable(handles);
    on_disconnect(handles);
    guidata(hObject, handles);
    return
end

resp = handles.fir.run('10'); %init the guy

if isempty(resp)
    handles.online = 0;
    errordlg('MBED has stopped responding: check for loose USB cable, and try to reset before reconnecting.','Connection lost','modal')
    renable(handles);
    on_disconnect(handles);
    guidata(hObject, handles);
    return
end

if handles.sid < 2
    handles.compare = 1;
end

[what,handles] = numerical(handles, 1);

if what
    handles.online = 0;
    errordlg('MBED has stopped responding: check for loose USB cable, and try to reset before reconnecting.','Connection lost','modal')
    on_disconnect(handles);
end

    renable(handles);

guidata(hObject, handles);

    function on_disconnect(handles)
        handles.tool.delete;
        delete(instrfind({'Port'},{handles.comport}));
        set(handles.portsel, 'Enable', 'On');
        set(handles.Refresh, 'Enable', 'On');
        serialInfo = instrhwinfo('serial');
        set(handles.mbedstatus, 'String', 'OFFLINE');
        set(handles.mbedstatus, 'ForegroundColor', [0 0 0]);
        if isempty(serialInfo.AvailableSerialPorts)
            set(handles.portsel, 'String', ' ');
            handles.comport = 0;
            set(handles.Connect, 'Enable', 'Off');
        else
            set(handles.portsel, 'String', serialInfo.AvailableSerialPorts);
            set(handles.portsel, 'Value', 1);
            handles.comport = serialInfo.AvailableSerialPorts{1};
            set(handles.Connect, 'Enable', 'On');
        end

% --- Executes on slider movement.
function phaseset_Callback(hObject, eventdata, handles)
% hObject    handle to phaseset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
poser = get(hObject,'Value');
poser = round(poser)/-100;
newtext = sprintf('Phase shift : %1.2f rad', poser);
set(handles.text7,'String',newtext);
handles.phaset = poser;
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function phaseset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to phaseset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function pulsepos_Callback(hObject, eventdata, handles)
% hObject    handle to pulsepos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of pulsepos as text
%        str2double(get(hObject,'String')) returns contents of pulsepos as a double
input = str2num(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.pulsepos, 'String', handles.ppost);
  uicontrol(hObject)
  return
else
    if input < 0
        errordlg('Pulse position should be positive','Invalid Input','modal')
        set(handles.pulsepos, 'String', handles.ppost);
        uicontrol(hObject)
        return
    else
         if ~(input == fix(input))
            errordlg('Pulse position should be an integer','Invalid Input','modal')
            set(handles.pulsepos, 'String', handles.ppost);
            uicontrol(hObject)
            return
        else
            handles.ppost = input;
        end
    end
end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function pulsepos_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pulsepos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when selected object is changed in uipanel2.
function uipanel2_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanel2 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
if strcmpi(get(eventdata.NewValue, 'Tag'),'radiobutton1')
   handles.domain = 1;
end
if strcmpi(get(eventdata.NewValue, 'Tag'),'radiobutton2')
   handles.domain = 2;
end
   handles.spectrum = plotter(handles, 1);
   plotter(handles, 2);
   resizer(handles);

guidata(hObject, handles);


% --- Executes on slider movement.
function frameset_Callback(hObject, eventdata, handles)
% hObject    handle to frameset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
poser = get(hObject,'Value');
poser = round(poser);
newtext = sprintf('Signal duration : %d ms', poser);
set(handles.text8,'String',newtext);
handles.timeframe = poser;
if handles.newsig == 0
    handles.sine = displayer(handles);
end
if handles.newsig == 1
    handles.sine = pulserender(handles);
end
handles.spectrum = plotter(handles, 1);
plotter(handles, 2);
resizer(handles);

if poser > 20
    if poser > 35
        handles.packet = 50;
        set(handles.blocksize, 'Value', 3);
    else
        handles.packet = 25;
        set(handles.blocksize, 'Value', 2);
    end
else
    handles.packet = 10;
    set(handles.blocksize, 'Value', 1);
end

guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function frameset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to frameset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

    function discon = firkoeff(handles)
        
    discon = 0;
        
    if handles.fstager < 3  %if coefficients are less than four
        coepack = [0 0 0 0];
        if handles.fstager == 1
            coepack(4) = handles.fircoeffs(1);
            coepack(3) = handles.fircoeffs(2);
        end
        if handles.fstager == 2
            coepack(4) = handles.fircoeffs(1);
            coepack(3) = handles.fircoeffs(2);
            coepack(2) = handles.fircoeffs(3);
        end
    else
        if mod(handles.fstager, 2) %check if order is even
            coepack = zeros(1,handles.fstager+1);
            for moar = 1:handles.fstager+1
                coepack(moar) = handles.fircoeffs((handles.fstager+2)-moar);            
            end %reshuffling the coefficients for the whiny fixed point filter
        else
            coepack = zeros(1,handles.fstager+2);
            for moar = 2:handles.fstager+2
                coepack(moar) = handles.fircoeffs((handles.fstager+3)-moar);                
            end %reshuffling the coefficients for the whiny fixed point filter
        end
    end
    
    datar = cellfun(@num2str, num2cell(coepack), 'UniformOutput', false);
    
    for idtx = 1:numel(datar)                  %set coefficients
        element = datar{idtx};
        str = sprintf('1 %d %s',idtx,element);
        out = handles.setta.run(str);
        if isempty(out)
            discon = 1;
            return
        end
    end
    
    str = sprintf('5 %d %d',handles.packet,numel(coepack));
    handles.setta.run(str);
    out = handles.setta.run(str);
    if isempty(out)
        discon = 1;
        return
    end
    
    function discon = iirkoeff(handles)
        
    discon = 0;
        
    postshift = 0;
        
    if handles.istager == 1
        coepack = zeros(0,6);
        taps = 6;
    else
        coepack = zeros(0,12);
        taps = 12;
    end
    
    for m = 1:taps
        coepack(m) = handles.iircoeffs(m);
    end
    
    while (abs(max(coepack)) > 1)
        coepack = coepack / 2;
        postshift = postshift + 1;
    end
	
    datar = cellfun(@num2str, num2cell(coepack), 'UniformOutput', false);
    
    for idtx = 1:numel(datar)                  %set coefficients
        element = datar{idtx};
        str = sprintf('7 %d %s',idtx,element);
        out = handles.setta.run(str);
        if isempty(out)
            discon = 1;
            return
        end
    end
    
    str = sprintf('9 %d %d %d',handles.packet,handles.istager,postshift);
    handles.setta.run(str);
    out = handles.setta.run(str);
    if isempty(out)
            discon = 1;
            return
    end

    function renable(handles)
    
    set(handles.radiobutton1, 'Enable', 'On');
    set(handles.radiobutton2, 'Enable', 'On');
    set(handles.frameset, 'Enable', 'On');
    set(handles.pulsepos, 'Enable', 'On');

    set(handles.phaseset, 'Enable', 'On');
    set(handles.PhasReset, 'Enable', 'On');
    set(handles.amplitude, 'Enable', 'On');
    set(handles.samplefreq, 'Enable', 'On');
    set(handles.ShowCoeffs, 'Enable', 'On');
    set(handles.ShowAxes, 'Enable', 'On');
    set(handles.frequency, 'Enable', 'On');
    set(handles.ProcessStop, 'Enable', 'Off');
    set(handles.blocksize, 'Enable', 'On');
    
    if handles.pulsator
        set(handles.pulsegen, 'Enable', 'On');
        set(handles.Blanking, 'Enable', 'On');
    else if handles.newsig
            set(handles.pulsegen, 'Enable', 'On');
            set(handles.addsinebutton, 'Enable', 'On');
        else
            set(handles.addsinebutton, 'Enable', 'On');
            set(handles.Blanking, 'Enable', 'On');
        end
    end
    
    if handles.online
        set(handles.ProcessIir, 'Enable', 'On');
        set(handles.ProcessFir, 'Enable', 'On');
    end
    
    function rdisable(handles)
        
    set(handles.radiobutton1, 'Enable', 'Off');
    set(handles.radiobutton2, 'Enable', 'Off');
    set(handles.frameset, 'Enable', 'Off');
    set(handles.pulsepos, 'Enable', 'Off');
    set(handles.addsinebutton, 'Enable', 'Off');
    set(handles.Blanking, 'Enable', 'Off');
    set(handles.pulsegen, 'Enable', 'Off');
    set(handles.phaseset, 'Enable', 'Off');
    set(handles.PhasReset, 'Enable', 'Off');
    set(handles.frequency, 'Enable', 'Off');
    set(handles.amplitude, 'Enable', 'Off');
    set(handles.samplefreq, 'Enable', 'Off');
    set(handles.ProcessStop, 'Enable', 'On');
    set(handles.ShowCoeffs, 'Enable', 'Off');
    set(handles.ProcessIir, 'Enable', 'Off');
    set(handles.ProcessFir, 'Enable', 'Off');
    set(handles.ShowAxes, 'Enable', 'Off');
    set(handles.blocksize, 'Enable', 'Off');
    

% --------------------------------------------------------------------
function ShowCoeffs_ClickedCallback(hObject, eventdata, handles)
% hObject    handle to ShowCoeffs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.ShowCoeffs, 'State', 'On');

guidata(hObject, handles);



% --------------------------------------------------------------------
function ShowCoeffs_OnCallback(hObject, eventdata, handles)
% hObject    handle to ShowCoeffs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if handles.show == 1

    set(handles.ShowAxes, 'State', 'Off');

    delete(handles.axes1);
    delete(handles.axes3);

    set(handles.firtxt, 'Visible', 'On');
    set(handles.iirtxt, 'Visible', 'On');
    set(handles.firstages, 'Visible', 'On');
    set(handles.iirstages1, 'Visible', 'On');
    set(handles.iirstages2, 'Visible', 'On');

    set(handles.firpanel, 'Visible', 'On');
    set(handles.iirpanel1, 'Visible', 'On');
    set(handles.unit1, 'Visible', 'Off');
    set(handles.unit2, 'Visible', 'Off');
    set(handles.unitdb, 'Visible', 'Off');

    if handles.istager == 2
        set(handles.iirpanel2, 'Visible', 'On');
    end

    set(handles.radiobutton1, 'Enable', 'Off');
    set(handles.radiobutton2, 'Enable', 'Off');
    set(handles.frameset, 'Enable', 'Off');
    set(handles.pulsepos, 'Enable', 'Off');
    set(handles.addsinebutton, 'Enable', 'Off');
    set(handles.Blanking, 'Enable', 'Off');
    set(handles.pulsegen, 'Enable', 'Off');
    set(handles.phaseset, 'Enable', 'Off');
    set(handles.PhasReset, 'Enable', 'Off');
    set(handles.amplitude, 'Enable', 'Off');
    set(handles.ProcessIir, 'Enable', 'Off');
    set(handles.ProcessFir, 'Enable', 'Off');
    set(handles.frequency, 'Enable', 'Off');
    set(handles.blocksize, 'Enable', 'Off');

        if handles.online
            set(handles.LaunchFir, 'Enable', 'On');
            set(handles.LaunchIir, 'Enable', 'On');
        end

    handles.show = 2;

end

guidata(hObject, handles);



function firb0_Callback(hObject, eventdata, handles)
% hObject    handle to firb0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of firb0 as text
%        str2double(get(hObject,'String')) returns contents of firb0 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.firb0, 'String', handles.fircoeffs(1));
  uicontrol(hObject)
  return
else
    if abs(input) > 1
      errordlg('FIR coefficient should be in limits [-1, +1]','Invalid Input','modal')
      set(handles.firb0, 'String', handles.fircoeffs(1));
      uicontrol(hObject)
      return
    else
        handles.fircoeffs(1) = input;
    end
end
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function firb0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to firb0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function firb1_Callback(hObject, eventdata, handles)
% hObject    handle to firb1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of firb1 as text
%        str2double(get(hObject,'String')) returns contents of firb1 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.firb1, 'String', handles.fircoeffs(2));
  uicontrol(hObject)
  return
else
    if abs(input) > 1
      errordlg('FIR coefficient should be in limits [-1, +1]','Invalid Input','modal')
      set(handles.firb1, 'String', handles.fircoeffs(2));
      uicontrol(hObject)
      return
    else
        handles.fircoeffs(2) = input;
    end
end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function firb1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to firb1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function firb2_Callback(hObject, eventdata, handles)
% hObject    handle to firb2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of firb2 as text
%        str2double(get(hObject,'String')) returns contents of firb2 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.firb2, 'String', handles.fircoeffs(3));
  uicontrol(hObject)
  return
else
    if abs(input) > 1
      errordlg('FIR coefficient should be in limits [-1, +1]','Invalid Input','modal')
      set(handles.firb2, 'String', handles.fircoeffs(3));
      uicontrol(hObject)
      return
    else
        handles.fircoeffs(3) = input;
    end
end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function firb2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to firb2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function firb3_Callback(hObject, eventdata, handles)
% hObject    handle to firb3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of firb3 as text
%        str2double(get(hObject,'String')) returns contents of firb3 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.firb3, 'String', handles.fircoeffs(4));
  uicontrol(hObject)
  return
else
    if abs(input) > 1
      errordlg('FIR coefficient should be in limits [-1, +1]','Invalid Input','modal')
      set(handles.firb3, 'String', handles.fircoeffs(4));
      uicontrol(hObject)
      return
    else
        handles.fircoeffs(4) = input;
    end
end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function firb3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to firb3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function firb4_Callback(hObject, eventdata, handles)
% hObject    handle to firb4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of firb4 as text
%        str2double(get(hObject,'String')) returns contents of firb4 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.firb4, 'String', handles.fircoeffs(5));
  uicontrol(hObject)
  return
else
    if abs(input) > 1
      errordlg('FIR coefficient should be in limits [-1, +1]','Invalid Input','modal')
      set(handles.firb4, 'String', handles.fircoeffs(5));
      uicontrol(hObject)
      return
    else
        handles.fircoeffs(5) = input;
    end
end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function firb4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to firb4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function firb5_Callback(hObject, eventdata, handles)
% hObject    handle to firb5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of firb5 as text
%        str2double(get(hObject,'String')) returns contents of firb5 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.firb5, 'String', handles.fircoeffs(6));
  uicontrol(hObject)
  return
else
    if abs(input) > 1
      errordlg('FIR coefficient should be in limits [-1, +1]','Invalid Input','modal')
      set(handles.firb5, 'String', handles.fircoeffs(6));
      uicontrol(hObject)
      return
    else
        handles.fircoeffs(6) = input;
    end
end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function firb5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to firb5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function firb6_Callback(hObject, eventdata, handles)
% hObject    handle to firb6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of firb6 as text
%        str2double(get(hObject,'String')) returns contents of firb6 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.firb6, 'String', handles.fircoeffs(7));
  uicontrol(hObject)
  return
else
    if abs(input) > 1
      errordlg('FIR coefficient should be in limits [-1, +1]','Invalid Input','modal')
      set(handles.firb6, 'String', handles.fircoeffs(7));
      uicontrol(hObject)
      return
    else
        handles.fircoeffs(7) = input;
    end
end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function firb6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to firb6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function firb7_Callback(hObject, eventdata, handles)
% hObject    handle to firb7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of firb7 as text
%        str2double(get(hObject,'String')) returns contents of firb7 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.firb7, 'String', handles.fircoeffs(8));
  uicontrol(hObject)
  return
else
    if abs(input) > 1
      errordlg('FIR coefficient should be in limits [-1, +1]','Invalid Input','modal')
      set(handles.firb7, 'String', handles.fircoeffs(8));
      uicontrol(hObject)
      return
    else
        handles.fircoeffs(8) = input;
    end
end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function firb7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to firb7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function firb8_Callback(hObject, eventdata, handles)
% hObject    handle to firb8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of firb8 as text
%        str2double(get(hObject,'String')) returns contents of firb8 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.firb8, 'String', handles.fircoeffs(9));
  uicontrol(hObject)
  return
else
    if abs(input) > 1
      errordlg('FIR coefficient should be in limits [-1, +1]','Invalid Input','modal')
      set(handles.firb8, 'String', handles.fircoeffs(9));
      uicontrol(hObject)
      return
    else
        handles.fircoeffs(9) = input;
    end
end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function firb8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to firb8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function firb9_Callback(hObject, eventdata, handles)
% hObject    handle to firb9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of firb9 as text
%        str2double(get(hObject,'String')) returns contents of firb9 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.firb9, 'String', handles.fircoeffs(10));
  uicontrol(hObject)
  return
else
    if abs(input) > 1
      errordlg('FIR coefficient should be in limits [-1, +1]','Invalid Input','modal')
      set(handles.firb9, 'String', handles.fircoeffs(10));      
      uicontrol(hObject)
      return
    else
        handles.fircoeffs(10) = input;
    end
end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function firb9_CreateFcn(hObject, eventdata, handles)
% hObject    handle to firb9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function iir2b0_Callback(hObject, eventdata, handles)
% hObject    handle to iir2b0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of iir2b0 as text
%        str2double(get(hObject,'String')) returns contents of iir2b0 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.iir2b0, 'String', handles.iircoeffs(7));
  uicontrol(hObject)
  return
else
        handles.iircoeffs(7) = input;
end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function iir2b0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to iir2b0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function iir2b1_Callback(hObject, eventdata, handles)
% hObject    handle to iir2b1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of iir2b1 as text
%        str2double(get(hObject,'String')) returns contents of iir2b1 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.iir2b1, 'String', handles.iircoeffs(9));
  uicontrol(hObject)
  return
else

        handles.iircoeffs(9) = input;

end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function iir2b1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to iir2b1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function iir2b2_Callback(hObject, eventdata, handles)
% hObject    handle to iir2b2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of iir2b2 as text
%        str2double(get(hObject,'String')) returns contents of iir2b2 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.iir2b2, 'String', handles.iircoeffs(10));
  uicontrol(hObject)
  return
else

        handles.iircoeffs(10) = input;

end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function iir2b2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to iir2b2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function iir2a1_Callback(hObject, eventdata, handles)
% hObject    handle to iir2a1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of iir2a1 as text
%        str2double(get(hObject,'String')) returns contents of iir2a1 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.iir2a1, 'String', handles.iircoeffs(11));
  uicontrol(hObject)
  return
else

        handles.iircoeffs(11) = input;

end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function iir2a1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to iir2a1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function iir2a2_Callback(hObject, eventdata, handles)
% hObject    handle to iir2a2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of iir2a2 as text
%        str2double(get(hObject,'String')) returns contents of iir2a2 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.iir2a2, 'String', handles.iircoeffs(12));
  uicontrol(hObject)
  return
else

        handles.iircoeffs(12) = input;

end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function iir2a2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to iir2a2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function iir1b0_Callback(hObject, eventdata, handles)
% hObject    handle to iir1b0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of iir1b0 as text
%        str2double(get(hObject,'String')) returns contents of iir1b0 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.iir1b0, 'String', handles.iircoeffs(1));
  uicontrol(hObject)
  return
else

        handles.iircoeffs(1) = input;

end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function iir1b0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to iir1b0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function iir1b1_Callback(hObject, eventdata, handles)
% hObject    handle to iir1b1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of iir1b1 as text
%        str2double(get(hObject,'String')) returns contents of iir1b1 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.iir1b1, 'String', handles.iircoeffs(3));
  uicontrol(hObject)
  return
else

        handles.iircoeffs(3) = input;

end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function iir1b1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to iir1b1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function iir1b2_Callback(hObject, eventdata, handles)
% hObject    handle to iir1b2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of iir1b2 as text
%        str2double(get(hObject,'String')) returns contents of iir1b2 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.iir1b2, 'String', handles.iircoeffs(4));
  uicontrol(hObject)
  return
else

        handles.iircoeffs(4) = input;

end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function iir1b2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to iir1b2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function iir1a1_Callback(hObject, eventdata, handles)
% hObject    handle to iir1a1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of iir1a1 as text
%        str2double(get(hObject,'String')) returns contents of iir1a1 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.iir1a1, 'String', handles.iircoeffs(5));
  uicontrol(hObject)
  return
else

        handles.iircoeffs(5) = input;
        
end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function iir1a1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to iir1a1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function iir1a2_Callback(hObject, eventdata, handles)
% hObject    handle to iir1a2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of iir1a2 as text
%        str2double(get(hObject,'String')) returns contents of iir1a2 as a double

input = str2double(get(hObject,'String'));
if isnan(input)
  errordlg('You must enter a numeric value','Invalid Input','modal')
  set(handles.iir1a2, 'String', handles.iircoeffs(6));
  uicontrol(hObject)
  return
else

        handles.iircoeffs(6) = input;

end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function iir1a2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to iir1a2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function ShowAxes_OnCallback(hObject, eventdata, handles)
% hObject    handle to ShowAxes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if handles.show == 2;

    set(handles.ShowCoeffs, 'State', 'Off');

    set(handles.firtxt, 'Visible', 'Off');
    set(handles.iirtxt, 'Visible', 'Off');
    set(handles.firstages, 'Visible', 'Off');
    set(handles.iirstages1, 'Visible', 'Off');
    set(handles.iirstages2, 'Visible', 'Off');

    set(handles.firpanel, 'Visible', 'Off');
    set(handles.iirpanel1, 'Visible', 'Off');
    set(handles.iirpanel2, 'Visible', 'Off');

    handles.axes1 = axes('Position', [0.2971014492753623,0.5580029368575625,0.6417069243156199,0.406754772393539]);
    handles.axes3 = axes('Position', [0.2971014492753623,0.0763582966226138,0.6409017713365541,0.4155653450807636]);
    set(handles.unit1, 'Visible', 'On');
    set(handles.unit2, 'Visible', 'On');

    plotter(handles, 1);
    plotter(handles, 2);
    resizer(handles);

    set(handles.radiobutton1, 'Enable', 'On');
    set(handles.radiobutton2, 'Enable', 'On');
    set(handles.frameset, 'Enable', 'On');
    set(handles.pulsepos, 'Enable', 'On');

    set(handles.phaseset, 'Enable', 'On');
    set(handles.PhasReset, 'Enable', 'On');
    set(handles.frequency, 'Enable', 'On');
    set(handles.amplitude, 'Enable', 'On');
    set(handles.LaunchFir, 'Enable', 'Off');
    set(handles.LaunchIir, 'Enable', 'Off');
    set(handles.blocksize, 'Enable', 'On');

        if handles.pulsator
            set(handles.pulsegen, 'Enable', 'On');
            set(handles.Blanking, 'Enable', 'On');
        else if handles.newsig
                set(handles.pulsegen, 'Enable', 'On');
                set(handles.addsinebutton, 'Enable', 'On');
            else
                set(handles.addsinebutton, 'Enable', 'On');
                set(handles.Blanking, 'Enable', 'On');
            end
        end

    if handles.online
        set(handles.ProcessIir, 'Enable', 'On');
        set(handles.ProcessFir, 'Enable', 'On');
    end

    handles.show = 1;

end

guidata(hObject, handles);


% --------------------------------------------------------------------
function ShowAxes_ClickedCallback(hObject, eventdata, handles)
% hObject    handle to ShowAxes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.ShowAxes, 'State', 'On');

guidata(hObject, handles);


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if handles.online
    delete(instrfind({'Port'},{handles.comport}));
end
% Hint: delete(hObject) closes the figure
delete(hObject);

% --- Executes on button press in Connect.
function Connect_Callback(hObject, eventdata, handles)
% hObject    handle to Connect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

try
    handles.tool = mbed.SerialRPC(handles.comport, 9600);
catch
    errordlg('Selected port is not responding. Select port with right MBED and make sure, that it is programmed with test platform code.','Device is not found','modal')
    return
end

handles.fir = mbed.RPCFunction(handles.tool, 'fir');
handles.iir = mbed.RPCFunction(handles.tool, 'iir');
handles.setta = mbed.RPCFunction(handles.tool, 'coeffs');
handles.transport = mbed.RPCFunction(handles.tool, 'tporter');
handles.launcher = mbed.RPCFunction(handles.tool, 'launcher');

    
set(handles.Connect, 'Enable', 'Off');
set(handles.portsel, 'Enable', 'Off');
set(handles.Refresh, 'Enable', 'Off');
if handles.show == 1
    set(handles.ProcessFir, 'Enable', 'On');
    set(handles.ProcessIir, 'Enable', 'On');
else
    set(handles.LaunchFir, 'Enable', 'On');
    set(handles.LaunchIir, 'Enable', 'On');
end
set(handles.mbedstatus, 'String', 'ONLINE');
set(handles.mbedstatus, 'ForegroundColor', [0.4 0.8 0]);
handles.online = 1;

guidata(hObject, handles);


% --- Executes on button press in PhasReset.
function PhasReset_Callback(hObject, eventdata, handles)
% hObject    handle to PhasReset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.phaseset, 'Value', 0);
handles.phaset = 0;

set(handles.text7,'String','Phase shift : 0.00 rad');

guidata(hObject, handles);


% --- Executes on selection change in firstages.
function firstages_Callback(hObject, eventdata, handles)
% hObject    handle to firstages (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns firstages contents as cell array
%        contents{get(hObject,'Value')} returns selected item from firstages

input = get(hObject,'Value');

if input > 1
    set(handles.text13, 'Visible', 'On');
    set(handles.firb2, 'Visible', 'On');
    if input > 2
         set(handles.text14, 'Visible', 'On');
         set(handles.firb3, 'Visible', 'On');
        if input > 3
             set(handles.text15, 'Visible', 'On');
             set(handles.firb4, 'Visible', 'On');
            if input > 4
                 set(handles.text16, 'Visible', 'On');
                 set(handles.firb5, 'Visible', 'On');
                if input > 5
                     set(handles.text17, 'Visible', 'On');
                     set(handles.firb6, 'Visible', 'On');
                    if input > 6
                         set(handles.text18, 'Visible', 'On');
                         set(handles.firb7, 'Visible', 'On');
                        if input > 7
                             set(handles.text19, 'Visible', 'On');
                             set(handles.firb8, 'Visible', 'On');
                            if input > 8
                                 set(handles.text20, 'Visible', 'On');
                                 set(handles.firb9, 'Visible', 'On');
                            end
                        end
                    end
                end
            end
        end
    end
end

if input < 9
    set(handles.text20, 'Visible', 'Off');
    set(handles.firb9, 'Visible', 'Off');
    if input < 8
         set(handles.text19, 'Visible', 'Off');
         set(handles.firb8, 'Visible', 'Off');
        if input < 7
             set(handles.text18, 'Visible', 'Off');
             set(handles.firb7, 'Visible', 'Off');
            if input < 6
                 set(handles.text17, 'Visible', 'Off');
                 set(handles.firb6, 'Visible', 'Off');
                if input < 5
                     set(handles.text16, 'Visible', 'Off');
                     set(handles.firb5, 'Visible', 'Off');
                    if input < 4
                         set(handles.text15, 'Visible', 'Off');
                         set(handles.firb4, 'Visible', 'Off');
                        if input < 3
                             set(handles.text14, 'Visible', 'Off');
                             set(handles.firb3, 'Visible', 'Off');
                            if input < 2
                                 set(handles.text13, 'Visible', 'Off');
                                 set(handles.firb2, 'Visible', 'Off');
                            end
                        end
                    end
                end
            end
        end
    end
end

handles.fstager = input;
    
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function firstages_CreateFcn(hObject, eventdata, handles)
% hObject    handle to firstages (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in iirstages1.
function iirstages1_Callback(hObject, eventdata, handles)
% hObject    handle to iirstages1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of iirstages1

set(handles.iirstages2, 'Value', 0);
set(handles.iirstages1, 'Value', 1);

handles.istager = 1;
set(handles.iirpanel2, 'Visible', 'Off');

guidata(hObject, handles);


% --- Executes on button press in iirstages2.
function iirstages2_Callback(hObject, eventdata, handles)
% hObject    handle to iirstages2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of iirstages2

set(handles.iirstages1, 'Value', 0);
set(handles.iirstages2, 'Value', 1);

handles.istager = 2;
set(handles.iirpanel2, 'Visible', 'On');

guidata(hObject, handles);

% --- Executes on button press in LaunchFir.
function LaunchFir_Callback(hObject, eventdata, handles)
% hObject    handle to LaunchFir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.LaunchFir, 'Enable', 'Off');
set(handles.LaunchIir, 'Enable', 'Off');

what = firkoeff(handles);

if what
    handles.online = 0;
    errordlg('MBED has stopped responding: check for loose USB cable, and try to reset before reconnecting.','Connection lost','modal')
    on_disconnect(handles);
    guidata(hObject, handles);
    return
end

str = sprintf('1 %d',handles.stiming);
resp = handles.launcher.run(str); %init the guy

if isempty(resp)
    handles.online = 0;
    errordlg('MBED has stopped responding: check for loose USB cable, and try to reset before reconnecting.','Connection lost','modal')
    on_disconnect(handles);
    guidata(hObject, handles);
    return
end

handles.online = 0;
on_disconnect(handles);

guidata(hObject, handles);



% --- Executes on button press in LaunchIir.
function LaunchIir_Callback(hObject, eventdata, handles)
% hObject    handle to LaunchIir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.LaunchFir, 'Enable', 'Off');
set(handles.LaunchIir, 'Enable', 'Off');

what = iirkoeff(handles);

if what
    handles.online = 0;
    errordlg('MBED has stopped responding: check for loose USB cable, and try to reset before reconnecting.','Connection lost','modal')
    on_disconnect(handles);
    guidata(hObject, handles);
    return
end

str = sprintf('2 %d',handles.stiming);
resp = handles.launcher.run(str); %init the guy

if isempty(resp)
    handles.online = 0;
    errordlg('MBED has stopped responding: check for loose USB cable, and try to reset before reconnecting.','Connection lost','modal')
    on_disconnect(handles);
    guidata(hObject, handles);
    return
end

handles.online = 0;
on_disconnect(handles);

guidata(hObject, handles);

% --- Executes on button press in ProcessIir.
function ProcessIir_Callback(hObject, eventdata, handles)
% hObject    handle to ProcessIir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.radiobutton1, 'Value', 1);
set(handles.radiobutton2, 'Value', 0);

handles.domain = 1;
handles.satur = 0;

plotter(handles, 1);
plotter(handles, 2);
resizer(handles);

rdisable(handles);

set(handles.figure1, 'UserData', 0);    %set an interrupt requirement

what = iirkoeff(handles);

if what
    handles.online = 0;
    errordlg('MBED has stopped responding: check for loose USB cable, and try to reset before reconnecting.','Connection lost','modal')
    renable(handles);
    on_disconnect(handles);
    guidata(hObject, handles);
    return
end

resp = handles.iir.run('10'); %init the guy

if isempty(resp)
    handles.online = 0;
    errordlg('MBED has stopped responding: check for loose USB cable, and try to reset before reconnecting.','Connection lost','modal')
    renable(handles);
    on_disconnect(handles);
    guidata(hObject, handles);
    return
end

if handles.sid < 2
    handles.compare = 1;
end

[what,handles] = numerical(handles, 2);

if what
    handles.online = 0;
    errordlg('MBED has stopped responding: check for loose USB cable, and try to reset before reconnecting.','Connection lost','modal')
    on_disconnect(handles);
end

    renable(handles);

guidata(hObject, handles);

    function [discon,handles] = numerical(handles, filter)
        
discon = 0;

aww = 'v';

scaler = max(abs(handles.sine)) / 0.99986;
if scaler < 1
    scaler = 1;
end
datain = handles.sine / scaler;
datar = cellfun(@num2str, num2cell(datain), 'UniformOutput', false);
frame = handles.packet;
size = numel(datar);
fullblocks = floor(size/frame);
tail = size - fullblocks*frame;
ptr = 0;
handles.processed = double.empty(0,size);
handles.time2 = double.empty(0,size);
timestep = 1/handles.sampfreq;
time = 0;
handles.processed(1) = 0;
handles.processed(2) = 0;
handles.time2(1) = 0;
handles.time2(2) = timestep;

for idx = 1:fullblocks               %format and send each block one value at a time
    for idtx = 1:frame                  %block being sent for processing
        element = datar{ptr+idtx};
        str = sprintf('1 %d %s',idtx,element);
        aww = handles.transport.run(str);
        if isempty(aww)
            discon = 1;
            return
        end
        drawnow
        if (get(handles.figure1, 'UserData') == 1);
            return
        end
    end
    
    if (filter == 1)
        aww = handles.fir.run('2');                        %processing function call here
    else
        aww = handles.iir.run('2');
    end
        if isempty(aww)
            discon = 1;
            return
        end
          
    for idrx = 1:frame                   %recover processed block
        enquiry = sprintf('2 %d',idrx);
        mess = handles.transport.run(enquiry);
        if isempty(mess)
            discon = 1;
            return
        else
            point = str2double(mess);
        end
        if abs(point) > 0.99986
            handles.satur = 1;
            scaler = scaler * 0.99986;
        end
        handles.processed(ptr+idrx) = point*scaler;
        handles.time2(ptr+idrx) = time;
        time = time + timestep;
        drawnow
        if (get(handles.figure1, 'UserData') == 1);
            return
        end
    end
    plotter(handles, 2);
    resizer(handles);
    
    ptr = ptr + frame;                 %increment the matlab array pointer
end

for idtx = 1:tail                   %send the tail
    element = datar{ptr+idtx};
    str = sprintf('1 %d %s',idtx,element);
    aww = handles.transport.run(str);
        if isempty(aww)
            discon = 1;
            return
        end
        drawnow
        if (get(handles.figure1, 'UserData') == 1);
            return
        end
end

for idtx = (tail+1):(frame-tail)           %fill the rest of tail block with zeros
    str = sprintf('1 %d 0',idtx);
    aww = handles.transport.run(str);
        if isempty(aww)
            discon = 1;
            return
        end
        drawnow
        if (get(handles.figure1, 'UserData') == 1);
            return
        end
end

    if (filter == 1)
        aww = handles.fir.run('2');                        %processing function call here
    else
        aww = handles.iir.run('2');
    end
        if isempty(aww)
            discon = 1;
            return
        end
    
for idrx = 1:tail                    %recover only the tail, ignore overhead
    enquiry = sprintf('2 %d',idrx);
    mess = handles.transport.run(enquiry);
    if isempty(mess)
        discon = 1;
        return
    else
        point = str2double(mess);
    end
    if abs(point) > 0.99986
        handles.satur = 1;
        scaler = scaler * 0.99986;
    end
    handles.processed(ptr+idrx) = point*scaler;
    handles.time2(ptr+idrx) = time;
    time = time + timestep;
        drawnow
        if (get(handles.figure1, 'UserData') == 1);
            return
        end
end

    plotter(handles, 2);
    resizer(handles);


% --- Executes on button press in ProcessStop.
function ProcessStop_Callback(hObject, eventdata, handles)
% hObject    handle to ProcessStop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%setappdata(hObject, 'CallbackRun', 1);
set(handles.figure1, 'UserData', 1);

guidata(hObject, handles);


% --- Executes on selection change in portsel.
function portsel_Callback(hObject, eventdata, handles)
% hObject    handle to portsel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns portsel contents as cell array
%        contents{get(hObject,'Value')} returns selected item from portsel

contents = cellstr(get(hObject,'String'));
handles.comport = contents{get(hObject,'Value')};

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function portsel_CreateFcn(hObject, eventdata, handles)
% hObject    handle to portsel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Refresh.
function Refresh_Callback(hObject, eventdata, handles)
% hObject    handle to Refresh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

serialInfo = instrhwinfo('serial');
if isempty(serialInfo.AvailableSerialPorts)
    set(handles.portsel, 'String', ' ');
    handles.comport = 0;
    set(handles.Connect, 'Enable', 'Off');
else
    set(handles.portsel, 'String', serialInfo.AvailableSerialPorts);
    handles.comport = serialInfo.AvailableSerialPorts{1};
    set(handles.Connect, 'Enable', 'On');
end

guidata(hObject, handles);


% --- Executes on selection change in blocksize.
function blocksize_Callback(hObject, eventdata, handles)
% hObject    handle to blocksize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns blocksize contents as cell array
%        contents{get(hObject,'Value')} returns selected item from blocksize

input = get(hObject,'Value');

switch input
    case 1
        handles.packet = 10;
    case 2
        handles.packet = 25;
    case 3
        handles.packet = 50;
    otherwise
        return
end

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function blocksize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to blocksize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
